#include <vcl.h>
#include <stdio.h>
#include <alloc.h>
#include <math.h>
//##################################
//##################################
class button
{
 public:
 Graphics::TBitmap *normal;
 Graphics::TBitmap *active;
 Graphics::TBitmap *normal_mask;
 Graphics::TBitmap *active_mask;
 char type[10];
 int left,top,right,bottom,mouseon,prev;
 button();
 click(int x,int y,int button);
 check_mouse(int x,int y);
 load(char* configfile);
 int clicked;
 free();
};
//----------------------------------
class MENU
{
 public:
 int number_buttons;
 Graphics::TBitmap *BACK;
 Graphics::TBitmap *buferscreen;
 button* buttons[10];
 render(int x,int y);
 rendernext(int x,int y);
 MENU();
 clear();
 setmenu(char *fileadres,char *curdir);
 check(int x,int y,int button);
};
//-----------------------------------
class selectlevel
{
 public:
 int levels,openlevels,width,height,ony[10],onx,seted;
 Graphics::TBitmap *BACK;
 Graphics::TBitmap *render;
 Graphics::TBitmap *button;
 draw(int x,int y);
 selectlevel();
 setmenu(char *curdir);
 check(int x,int y,int button);
 int clicked,numlevelselected;
 char *maps[100][10];
 free();

};
//-----------------------------------
class scrollbar
{
 public:
 int left,top,loaded;
 int max,min,position,prevposition;
 double step;
 Graphics::TBitmap *jumper;
 Graphics::TBitmap *jumper_mask;
 Graphics::TBitmap *background;
 Graphics::TBitmap *background_mask;
 Graphics::TBitmap *render;
 scrollbar();
 draw();
 int mouseon;
 check(int x,int y,int width);
 checkmousemove(int x,int y,int width);
 load(char *cfgadr);
};
//----------------------------------
class sidebar
{
 public:
 int loaded;
 scrollbar *mass1,*mass2,*length,*power;
 button *bigredbutton;
 Graphics::TBitmap *background;
 Graphics::TBitmap *render;
 sidebar();
 load(char *cfgadr);
 draw();
 draw_light();
 activation(int x,int y,int mousebutton);
 int left,width;

};
//##################################
//##################################
button::free()
{
 active->Free();
 active_mask->Free();
 active_mask->Free();
}
button::button()
{
int a;
a=a+2;
 normal=new Graphics::TBitmap;
 normal_mask=new Graphics::TBitmap;
 active=new Graphics::TBitmap;
 active_mask=new Graphics::TBitmap;
}
button::load(char* configfile)
{
 char buf[250],buf2[250];
 FILE *fil;
 if(fil=fopen(configfile,"rb"))
 {
  fscanf(fil,"%s ",buf);
  left=StrToInt(buf);
  fscanf(fil,"%s ",buf);
  top=StrToInt(buf);
  fscanf(fil,"%s ",buf);
  right=StrToInt(buf);
  fscanf(fil,"%s ",buf);
  bottom=StrToInt(buf);
  fscanf(fil,"%s ",type);
  fscanf(fil,"%s ",buf);
  sprintf(buf2,"hud\\%s",buf);
  normal->LoadFromFile(buf2);
  fscanf(fil,"%s",buf);
  sprintf(buf2,"hud\\%s",buf);
  active->LoadFromFile(buf2);
  fscanf(fil,"%s ",buf);
  sprintf(buf2,"hud\\%s",buf);
  normal_mask->LoadFromFile(buf2);
  fscanf(fil,"%s",buf);
  sprintf(buf2,"hud\\%s",buf);
  active_mask->LoadFromFile(buf2);
  fclose(fil);
 }


}
button::check_mouse(int x,int y)
{
 prev=mouseon;
 if (x>=left && x<=right && y>=top && y<=bottom)
 {
  prev=mouseon;
  mouseon=1;
  }
 else
 {
  prev=mouseon;
  mouseon=0;
 }
}
button::click(int x,int y,int button)
{
 prev=mouseon;
 if (x>=left && x<=right && y>=top && y<=bottom&& button==1)
 {
  prev=mouseon;
  mouseon=1;
  clicked=1;
 }

}

//********************************
//********************************
//********************************
selectlevel::free()
{
BACK->Free();
button->Free();
}
selectlevel::selectlevel()
{
 seted=0;
 BACK=new Graphics::TBitmap;
 render=new Graphics::TBitmap;
 button=new Graphics::TBitmap;
}
//---------------------------------
selectlevel::setmenu(char *curdir)
{
 char buf[250],buf2[250];
 FILE *fil;
 int a;
 sprintf(buf,"%s\\hud\\selectlevel.bmp",curdir);
 BACK->LoadFromFile(buf);
 sprintf(buf,"%s\\hud\\sellevbut.bmp",curdir);
 button->LoadFromFile(buf);
 sprintf(buf,"%s\\hud\\mci32.dll",curdir);
 fil=fopen(buf,"rb");
 fscanf(fil,"%s",buf);
 openlevels=StrToInt(buf);
 fclose(fil);
 sprintf(buf,"%s\\hud\\maps.cfg",curdir);
 fil=fopen(buf,"rb");
 fscanf(fil,"%s ",buf);
 levels=StrToInt(buf);
 for(a=1;a<=levels;a++)
 {
  fscanf(fil,"%s ",maps[a]);
 }
 seted=1;
}
//----------------------------
selectlevel::check(int x,int y,int button)
{
 int a,b,c;
 clicked=0;
 numlevelselected=0;
 int cc;
 cc=0;
 for(a=0;a<=onx;a++)
 {
  for(b=0;b<=ony[a];b++)
  {
   cc++;
   if(x>a*128&&x<a*128+128&&y>b*32&&y<b*32+32)
   {
    clicked=1;
    numlevelselected=cc;
    b=ony[onx];
    a=onx;
   }

  }
 }
 
}
selectlevel::draw(int x,int y)
{
 int a,b,c;
 Graphics::TBitmap *bufer=new Graphics::TBitmap;
 bufer->Width=128;
 bufer->Height=32;
 onx=0;
 b=openlevels;
 while(a)
 {
  if (b*32>height)
  {
   ony[onx]=height/32;
   onx++;
   b-=height/32;
  }
  else if(b*32<height)
  {
   ony[onx]=b;
   a=0;
  }
 }
 render->Width=width;
 render->Height=height;
 render->Canvas->CopyRect(Rect(0,0,width,height),BACK->Canvas,Rect(0,0,width,height));
 int cc;
 cc=1;
 for(a=0;a<=onx;a++)
 {
  for(b=0;b<=ony[a]-1;b++)
  {
    render->Canvas->CopyMode=cmSrcCopy;

    render->Canvas->CopyRect(Rect(a*128,b*32,a*128+128,b*32+32),button->Canvas,Rect(0,0,128,32));

   bufer->Canvas->Font->Size=24;
   bufer->Canvas->TextRect(Rect(0,0,128,32),0,0,cc);
   render->Canvas->CopyMode=cmSrcAnd;
   render->Canvas->CopyRect(Rect(a*128,b*32,a*128+128,b*32+32),bufer->Canvas,Rect(0,0,128,32));
   cc++;
  }
 }

}
//********************************
//********************************
//********************************
MENU::clear()
{
 BACK->Free();
 buferscreen->Free();
 int a;
 for(a=1;a<=number_buttons;a++)
 {
  buttons[a]->normal->Free();
  buttons[a]->active->Free();
  buttons[a]->normal_mask->Free();
  buttons[a]->active_mask->Free();
 }
}
MENU::MENU()
{
 int a;
 BACK=new Graphics::TBitmap;
 buferscreen=new Graphics::TBitmap;

}

MENU::check(int x,int y,int button)
{
  int a;
  for(a=1;a<=number_buttons;a++)
  {
   buttons[a]->check_mouse(x,y);
    if (button==1&& buttons[a]->mouseon==1)buttons[a]->clicked=1;

  }
}
MENU::setmenu(char *fileadres,char *curdir)
{
 char buf[250],buf2[250];
 int a;
 FILE *fil;
 fil=fopen(fileadres,"rb");
 fscanf(fil,"%s ",buf);
 sprintf(buf2,"%s\\hud\\%s",curdir,buf);
 BACK->LoadFromFile(buf2);
 buferscreen->Width=BACK->Width;
 buferscreen->Height=BACK->Height;
 fscanf(fil,"%s ",buf);
 number_buttons=StrToInt(buf);

 for(a=1;a<=number_buttons;a++)
 {
  buttons[a]=new button;
  fscanf(fil,"%s ",buf);
  sprintf(buf2,"%s\\hud\\%s",curdir,buf);
  buttons[a]->load(buf2);
 }
 fclose(fil);
}

MENU::render(int x,int y)
{
 int a;
 buferscreen->Canvas->CopyMode=cmSrcCopy;
 buferscreen->Canvas->CopyRect(Rect(0,0,buferscreen->Width,buferscreen->Height),BACK->Canvas,Rect(0,0,buferscreen->Width,buferscreen->Height));
 for (a=1;a<=number_buttons;a++)
 {
  buttons[a]->check_mouse(x,y);
  buferscreen->Canvas->CopyMode=cmSrcAnd;
  if (buttons[a]->mouseon==1)
   {
    buferscreen->Canvas->CopyRect(Rect(buttons[a]->left,buttons[a]->top,buttons[a]->right,buttons[a]->bottom),buttons[a]->active_mask->Canvas,Rect(0,0,buttons[a]->normal->Width,buttons[a]->normal->Height));
    buferscreen->Canvas->CopyMode=cmSrcPaint;
    buferscreen->Canvas->CopyRect(Rect(buttons[a]->left,buttons[a]->top,buttons[a]->right,buttons[a]->bottom),buttons[a]->active->Canvas,Rect(0,0,buttons[a]->normal->Width,buttons[a]->normal->Height));
   }
   if (buttons[a]->mouseon==0)
   {
    buferscreen->Canvas->CopyRect(Rect(buttons[a]->left,buttons[a]->top,buttons[a]->right,buttons[a]->bottom),buttons[a]->normal_mask->Canvas,Rect(0,0,buttons[a]->normal->Width,buttons[a]->normal->Height));
    buferscreen->Canvas->CopyMode=cmSrcPaint;
    buferscreen->Canvas->CopyRect(Rect(buttons[a]->left,buttons[a]->top,buttons[a]->right,buttons[a]->bottom),buttons[a]->normal->Canvas,Rect(0,0,buttons[a]->normal->Width,buttons[a]->normal->Height));
   }
 }
}
MENU::rendernext(int x,int y)
{
 int a;
  for (a=1;a<=number_buttons;a++)
 {
  buttons[a]->check_mouse(x,y);
  buferscreen->Canvas->CopyMode=cmSrcAnd;
  if (buttons[a]->mouseon==1&&buttons[a]->mouseon!=buttons[a]->prev)
   {
    buferscreen->Canvas->CopyRect(Rect(buttons[a]->left,buttons[a]->top,buttons[a]->right,buttons[a]->bottom),buttons[a]->active_mask->Canvas,Rect(0,0,buttons[a]->normal->Width,buttons[a]->normal->Height));
    buferscreen->Canvas->CopyMode=cmSrcPaint;
    buferscreen->Canvas->CopyRect(Rect(buttons[a]->left,buttons[a]->top,buttons[a]->right,buttons[a]->bottom),buttons[a]->active->Canvas,Rect(0,0,buttons[a]->normal->Width,buttons[a]->normal->Height));
   }
   if (buttons[a]->mouseon==0&&buttons[a]->mouseon!=buttons[a]->prev)
   {
    buferscreen->Canvas->CopyRect(Rect(buttons[a]->left,buttons[a]->top,buttons[a]->right,buttons[a]->bottom),buttons[a]->normal_mask->Canvas,Rect(0,0,buttons[a]->normal->Width,buttons[a]->normal->Height));
    buferscreen->Canvas->CopyMode=cmSrcPaint;
    buferscreen->Canvas->CopyRect(Rect(buttons[a]->left,buttons[a]->top,buttons[a]->right,buttons[a]->bottom),buttons[a]->normal->Canvas,Rect(0,0,buttons[a]->normal->Width,buttons[a]->normal->Height));
   }
 }
}
//********************************
//********************************
//********************************
scrollbar::scrollbar()
{
 jumper =new Graphics::TBitmap;
 jumper_mask = new Graphics::TBitmap;
 background = new Graphics::TBitmap;
 background_mask = new Graphics::TBitmap;
 render = new Graphics::TBitmap;
}
scrollbar::load(char *cfgadr)
{
 char buf[50],buf2[50];
 FILE *fil;
 if(fil=fopen(cfgadr,"rb"))
 {
  fscanf(fil,"%s ",buf);
  sprintf(buf2,"hud\\%s",buf);
  background->LoadFromFile(buf2);
  fscanf(fil,"%s ",buf);
  sprintf(buf2,"hud\\%s",buf);
  background_mask->LoadFromFile(buf2);
  fscanf(fil,"%s ",buf);
  sprintf(buf2,"hud\\%s",buf);
  jumper->LoadFromFile(buf2);
  fscanf(fil,"%s ",buf);
  sprintf(buf2,"hud\\%s",buf);
  jumper_mask->LoadFromFile(buf2);
  fscanf(fil,"%s ",buf);
  left=StrToInt(buf);
  fscanf(fil,"%s ",buf);
  top=StrToInt(buf);
  fscanf(fil,"%s ",buf);
  min=StrToInt(buf);
  fscanf(fil,"%s ",buf);
  max=StrToInt(buf);
  fscanf(fil,"%s ",buf);
  position=StrToInt(buf);
  fclose(fil);
  }
}
scrollbar::draw()
{
 render->Width=180;
 render->Height=64;
 render->Canvas->CopyMode=cmSrcAnd;
render->Canvas->CopyRect(Rect(0,0,render->Width,render->Height),background_mask->Canvas,Rect(0,0,background_mask->Width,background_mask->Height));
 render->Canvas->CopyMode=cmSrcCopy;
 render->Canvas->CopyRect(Rect(0,0,render->Width,render->Height),background->Canvas,Rect(0,0,background_mask->Width,background_mask->Height));
 render->Canvas->CopyMode=cmSrcAnd;
 render->Canvas->CopyRect(Rect(position*step+15-5,22,position*step+15+5,42),jumper_mask->Canvas,Rect(0,0,jumper_mask->Width,jumper_mask->Height));
 render->Canvas->CopyMode=cmSrcPaint;
 render->Canvas->CopyRect(Rect(position*step+15-5,22,position*step+15+5,42),jumper->Canvas,Rect(0,0,jumper_mask->Width,jumper_mask->Height));
}
scrollbar::check(int x,int y,int width)
{
 mouseon=0;
 if (y>=top+22&&y<=top+42&&x>=width+left&&x<=width+left+180)
 {
  mouseon=1;
  prevposition=position;
  step=(double)150/(max-min+1);
  if (step==0) step=0.01;
  position=(x-width-left+5-15)/step;
  position-=5;
  if (position<min)position=min;
  if (position>max)position=max;
 }
}
scrollbar::checkmousemove(int x,int y,int width)
{
 mouseon=0;
 if (y>=top+22&&y<=top+42&&x>=width+left+position*step&&x<=width+position*step+left+10)
 {mouseon=1;}
}
//********************************
//********************************
//********************************
sidebar::sidebar()
{
 render=new Graphics::TBitmap;
 background= new Graphics::TBitmap;
 mass1 =new scrollbar;
 mass2 =new scrollbar;
 length =new scrollbar;
 power =new scrollbar;
 bigredbutton=new button;
 loaded=0;
}
//-----------------------
sidebar::load(char*cfgadr)
{
 char buf[250],buf2[250];
 FILE *fil;
 if(fil=fopen(cfgadr,"rb"))
 {
  fscanf(fil,"%s ",buf);
  sprintf(buf2,"hud\\%s",buf);
  bigredbutton->load(buf2);
  fscanf(fil,"%s ",buf);
  sprintf(buf2,"hud\\%s",buf);
  mass1->load(buf2);
  fscanf(fil,"%s ",buf);
  sprintf(buf2,"hud\\%s",buf);
  mass2->load(buf2);
  fscanf(fil,"%s ",buf);
  sprintf(buf2,"hud\\%s",buf);
  length->load(buf2);
  fscanf(fil,"%s ",buf);
  sprintf(buf2,"hud\\%s",buf);
  power->load(buf2);
  fscanf(fil,"%s ",buf);
  sprintf(buf2,"hud\\%s",buf);
  background->LoadFromFile(buf2);
  fclose(fil);
 }
 loaded=1;
}

sidebar::draw()
{
 render->Width=200;
 render->Height=background->Height;
 render->Canvas->CopyMode=cmSrcCopy;
 render->Canvas->CopyRect(Rect(0,0,render->Width,render->Height),background->Canvas,Rect(0,0,background->Width,background->Height));
 render->Canvas->CopyMode=cmSrcAnd;
 if(bigredbutton->mouseon==1)
 {
  render->Canvas->CopyRect(Rect(bigredbutton->left,bigredbutton->top,bigredbutton->right,bigredbutton->bottom),bigredbutton->active_mask->Canvas,Rect(0,0,bigredbutton->right-bigredbutton->left,bigredbutton->bottom-bigredbutton->top));
  render->Canvas->CopyMode=cmSrcPaint;
  render->Canvas->CopyRect(Rect(bigredbutton->left,bigredbutton->top,bigredbutton->right,bigredbutton->bottom),bigredbutton->active->Canvas,Rect(0,0,bigredbutton->right-bigredbutton->left,bigredbutton->bottom-bigredbutton->top));
 }
  if(bigredbutton->mouseon==0)
 {
  render->Canvas->CopyRect(Rect(bigredbutton->left,bigredbutton->top,bigredbutton->right,bigredbutton->bottom),bigredbutton->normal_mask->Canvas,Rect(0,0,bigredbutton->right-bigredbutton->left,bigredbutton->bottom-bigredbutton->top));
  render->Canvas->CopyMode=cmSrcPaint;
  render->Canvas->CopyRect(Rect(bigredbutton->left,bigredbutton->top,bigredbutton->right,bigredbutton->bottom),bigredbutton->normal->Canvas,Rect(0,0,bigredbutton->right-bigredbutton->left,bigredbutton->bottom-bigredbutton->top));
 }
 render->Canvas->CopyMode=cmSrcAnd;
  mass1->draw();
  render->Canvas->CopyMode=cmSrcAnd;
  render->Canvas->CopyRect (Rect(mass1->left,mass1->top,mass1->left+180,mass1->top+64),mass1->background_mask->Canvas,Rect(0,0,mass1->background_mask->Width,mass1->background_mask->Height));
  render->Canvas->CopyMode=cmSrcPaint;
  render->Canvas->CopyRect (Rect(mass1->left,mass1->top,mass1->left+180,mass1->top+64),mass1->render->Canvas,Rect(0,0,mass1->background_mask->Width,mass1->background_mask->Height));

  mass2->draw();
  render->Canvas->CopyMode=cmSrcAnd;
  render->Canvas->CopyRect (Rect(mass2->left,mass2->top,mass2->left+180,mass2->top+64),mass2->background_mask->Canvas,Rect(0,0,mass2->background_mask->Width,mass2->background_mask->Height));
  render->Canvas->CopyMode=cmSrcPaint;
  render->Canvas->CopyRect (Rect(mass2->left,mass2->top,mass2->left+180,mass2->top+64),mass2->render->Canvas,Rect(0,0,mass2->background_mask->Width,mass2->background_mask->Height));

  length->draw();
  render->Canvas->CopyMode=cmSrcAnd;
  render->Canvas->CopyRect (Rect(length->left,length->top,length->left+180,length->top+64),length->background_mask->Canvas,Rect(0,0,length->background_mask->Width,length->background_mask->Height));
  render->Canvas->CopyMode=cmSrcPaint;
  render->Canvas->CopyRect (Rect(length->left,length->top,length->left+180,length->top+64),length->render->Canvas,Rect(0,0,length->background_mask->Width,length->background_mask->Height));

 power->draw();
  render->Canvas->CopyMode=cmSrcAnd;
  render->Canvas->CopyRect (Rect(power->left,power->top,power->left+180,power->top+64),power->background_mask->Canvas,Rect(0,0,power->background_mask->Width,power->background_mask->Height));
  render->Canvas->CopyMode=cmSrcPaint;
  render->Canvas->CopyRect (Rect(power->left,power->top,power->left+180,power->top+64),power->render->Canvas,Rect(0,0,power->background_mask->Width,power->background_mask->Height));
  power->prevposition=power->position;
 }
 //------------------
 sidebar::draw_light()
{
 render->Width=200;
 render->Height=background->Height;
 render->Canvas->CopyMode=cmSrcAnd;

 if(bigredbutton->mouseon==1)
 {
  render->Canvas->CopyRect(Rect(bigredbutton->left,bigredbutton->top,bigredbutton->right,bigredbutton->bottom),bigredbutton->active_mask->Canvas,Rect(0,0,bigredbutton->right-bigredbutton->left,bigredbutton->bottom-bigredbutton->top));
  render->Canvas->CopyMode=cmSrcPaint;
  render->Canvas->CopyRect(Rect(bigredbutton->left,bigredbutton->top,bigredbutton->right,bigredbutton->bottom),bigredbutton->active->Canvas,Rect(0,0,bigredbutton->right-bigredbutton->left,bigredbutton->bottom-bigredbutton->top));
 }
  else if(bigredbutton->mouseon==0)
 {
  render->Canvas->CopyRect(Rect(bigredbutton->left,bigredbutton->top,bigredbutton->right,bigredbutton->bottom),bigredbutton->normal_mask->Canvas,Rect(0,0,bigredbutton->right-bigredbutton->left,bigredbutton->bottom-bigredbutton->top));
  render->Canvas->CopyMode=cmSrcPaint;
  render->Canvas->CopyRect(Rect(bigredbutton->left,bigredbutton->top,bigredbutton->right,bigredbutton->bottom),bigredbutton->normal->Canvas,Rect(0,0,bigredbutton->right-bigredbutton->left,bigredbutton->bottom-bigredbutton->top));
 }
 render->Canvas->CopyMode=cmSrcAnd;

 if(mass1->prevposition!=mass1->position)
 {
  mass1->draw();
  render->Canvas->CopyMode=cmSrcAnd;
  render->Canvas->CopyRect (Rect(mass1->left,mass1->top,mass1->left+180,mass1->top+64),mass1->background_mask->Canvas,Rect(0,0,mass1->background_mask->Width,mass1->background_mask->Height));
  render->Canvas->CopyMode=cmSrcPaint;
  render->Canvas->CopyRect (Rect(mass1->left,mass1->top,mass1->left+180,mass1->top+64),mass1->render->Canvas,Rect(0,0,mass1->background_mask->Width,mass1->background_mask->Height));

  mass1->prevposition=mass1->position;
 }
 if(mass2->prevposition!=mass2->position)
 {
  mass2->draw();
  render->Canvas->CopyMode=cmSrcAnd;
  render->Canvas->CopyRect (Rect(mass2->left,mass2->top,mass2->left+180,mass2->top+64),mass2->background_mask->Canvas,Rect(0,0,mass2->background_mask->Width,mass2->background_mask->Height));
  render->Canvas->CopyMode=cmSrcPaint;
  render->Canvas->CopyRect (Rect(mass2->left,mass2->top,mass2->left+180,mass2->top+64),mass2->render->Canvas,Rect(0,0,mass2->background_mask->Width,mass2->background_mask->Height));

  mass2->prevposition=mass2->position;
 }
 if(length->prevposition!=length->position)
 {
  length->draw();
  render->Canvas->CopyMode=cmSrcAnd;
  render->Canvas->CopyRect (Rect(length->left,length->top,length->left+180,length->top+64),length->background_mask->Canvas,Rect(0,0,length->background_mask->Width,length->background_mask->Height));
  render->Canvas->CopyMode=cmSrcPaint;
  render->Canvas->CopyRect (Rect(length->left,length->top,length->left+180,length->top+64),length->render->Canvas,Rect(0,0,length->background_mask->Width,length->background_mask->Height));

  length->prevposition=length->position;
 }
 if(power->prevposition!=power->position)
 {
  power->draw();
  render->Canvas->CopyMode=cmSrcAnd;
  render->Canvas->CopyRect (Rect(power->left,power->top,power->left+180,power->top+64),power->background_mask->Canvas,Rect(0,0,power->background_mask->Width,power->background_mask->Height));
  render->Canvas->CopyMode=cmSrcPaint;
  render->Canvas->CopyRect (Rect(power->left,power->top,power->left+180,power->top+64),power->render->Canvas,Rect(0,0,power->background_mask->Width,power->background_mask->Height));
  power->prevposition=power->position;
 }
 }
 //----------------------
 sidebar::activation(int x,int y,int mousebutton)
 {
  if(x>(width-200))
  {
   bigredbutton->check_mouse(x-(width-200),y);
   if(mousebutton==1)
   {
    mass1->check(x-(width-200),y,left);
    mass2->check(x-(width-200),y,left);
    length->check(x-(width-200),y,left);
    power->check(x-(width-200),y,left);
    bigredbutton->click(x-(width-200),y,mousebutton);
   }
  }
 }
