#include <vcl/mplayer.hpp>
#include <alloc.h>
#include <stdio.h>
#include <time.h>
#include <stdlib>
#include <alloc.h>
#include <windef.h>
const int countmus=2;
class SoundEngine
{
 public:
 TMediaPlayer *sound;
 TMediaPlayer *music;
 int cursound,curmusic;
 SoundEngine(HWND hand);
 loadsound(int number);
 soundplay();
 loadmusic(int number);
 musicplay();
 randomplay();
};
//*********************************
SoundEngine::SoundEngine(HWND hand)
{
 sound=new TMediaPlayer(hand);
 music=new TMediaPlayer(hand);
 cursound=0;
 curmusic=0;
 sound->TimeFormat=tfMilliseconds;
}
//----------------------------------
SoundEngine::loadsound(int number)
{
 char *buf;
 cursound=number;
 buf=(char*)calloc(15,sizeof(char));
 sprintf(buf,"sound//%d.wav",number);
 sound->FileName=buf;
 sound->Open();
}
//----------------------------------
SoundEngine::loadmusic(int number)
{
 char *buf;
 curmusic=number;
 buf=(char*)calloc(15,sizeof(char));
 sprintf(buf,"sound//%d.mid",number);
 music->FileName=buf;
 music->Open();
}
//----------------------------------
SoundEngine::soundplay()
{

 if(sound->Position==sound->Length||sound->Position==0)
 {
  sound->Previous();
  sound->Play();
 }
}
//-----------------------------------
SoundEngine::musicplay()
{
 if(music->Position==music->Length||music->Position==0)
 {
  music->Previous();
  music->Play();
 }
}
//------------------------------------
SoundEngine::randomplay()
{
 int b,a;
 char *buf;
 FILE *fil;
 if(curmusic!=0&&music->Position==music->Length)
 {
  buf=(char*)calloc(5,1);
  fil=fopen("sound//mus.cfg","r");
  fscanf(fil," %c",buf);
  b=StrToInt(buf);
  randomize();
  a=random(1000);
  a%=b;

  if(a==0)a=1;
  music->Close();
  loadmusic(a);
  music->Play();
  free(buf);
   fclose(fil);
 }
 if(curmusic==0)
 {
  buf=(char*)calloc(5,1);
  fil=fopen("sound//mus.cfg","r");
  fscanf(fil," %c",buf);
  b=StrToInt(buf);
  randomize();
  a=random(1000);

  a%=b;
  curmusic=a;
  if(a==0)a=1;
  loadmusic(a);
  music->Play();
  free(buf);
   fclose(fil);
 }

}

